package com.company.XXXX.web.screens;

import com.company.XXXX.entity.FahrzeugDokument;
import com.company.XXXX.entity.FahrzeugDokumente;
import com.company.XXXX.service.DokumentService;
import com.haulmont.cuba.core.entity.FileDescriptor;
import com.haulmont.cuba.core.global.DataManager;
import com.haulmont.cuba.core.global.LoadContext;
import com.haulmont.cuba.gui.Dialogs;
import com.haulmont.cuba.gui.Notifications;
import com.haulmont.cuba.gui.app.core.inputdialog.DialogActions;
import com.haulmont.cuba.gui.app.core.inputdialog.InputDialog;
import com.haulmont.cuba.gui.app.core.inputdialog.InputParameter;
import com.haulmont.cuba.gui.components.*;
import com.haulmont.cuba.gui.model.CollectionContainer;
import com.haulmont.cuba.gui.model.CollectionLoader;
import com.haulmont.cuba.gui.screen.*;
import com.company.XXXX.entity.SplitPages;
import com.haulmont.cuba.core.global.Metadata;
import com.sun.org.apache.bcel.internal.generic.NEW;
import org.apache.pdfbox.pdmodel.PDDocument;
import org.omg.CORBA.NamedValue;
import org.springframework.beans.factory.annotation.Autowired;

import javax.inject.Inject;
import java.io.File;
import java.io.IOException;
import java.util.*;
import java.util.stream.Collectors;
import java.util.stream.Stream;

@UiController("XXXX_Documentsplitterscreen")
@UiDescriptor("documentSplitterScreen.xml")
public class Documentsplitterscreen extends Screen {

    @Inject
    DokumentService dokumentService;
    @Inject
    private BrowserFrame imagePreview;
    @Inject
    private Metadata metadata;
    @Inject
    private DataGrid<SplitPages> dgSplitPages;
    @Inject
    private CollectionContainer<SplitPages> splitPagesDc;
    @Inject
    private DataManager dataManager;
    @Inject
    private Dialogs dialogs;
    @Inject
    private MessageBundle messageBundle;
    @Inject
    private Notifications notifications;
    @Inject
    private Button btnSplitDocument;
    @Inject
    private Button delSplit;

    private FahrzeugDokument fahrzeugDokument;
    private FileDescriptor fd;
    int numberOfPages = 0;

    @Subscribe
    public void onBeforeShow(AfterShowEvent event) throws Exception {
        dgSplitPages.setVisible(false);
        btnSplitDocument.setEnabled(false);
        delSplit.setEnabled(false);
    }

    @Subscribe
    public void onAfterShow(AfterShowEvent event) throws Exception {
      if (getFd() != null) {
          imagePreview.setSource(FileDescriptorResource.class).setFileDescriptor(getFd());
          numberOfPages = dokumentService.getNumberOfDocPages(getFahrzeugDokument(), getFd());
       }
    }

    @Subscribe("dgSplitPages")
    public void onDgSplitPagesItemClick(DataGrid.ItemClickEvent<SplitPages> event) {
        if (event.isDoubleClick()) {
         SplitPages splitPages = event.getItem();
         editSplitPages(splitPages);
        }
    }

    @Subscribe("addSplit")
    public void onAddSplitClick(Button.ClickEvent event) {
        editSplitPages(null);
        delSplit.setEnabled(true);
    }

    @Subscribe("delSplit")
    public void onDelSplitClick(Button.ClickEvent event) {
        if(dgSplitPages.getSelected().size() > 0){
            splitPagesDc.getMutableItems().remove(dgSplitPages.getSingleSelected());
        }
        if(splitPagesDc.getMutableItems().size() == 0){
            dgSplitPages.setVisible(false);
            btnSplitDocument.setEnabled(false);
            delSplit.setEnabled(false);
        }
    }

    @Subscribe("close")
    public void onCloseClick(Button.ClickEvent event) {
        closeWithDefaultAction();
    }

    @Subscribe("btnSplitDocument")
    public void onBtnSplitDocumentClick(Button.ClickEvent event) throws Exception {

        boolean bOk = true;
        List<SplitPages> lstSplitPages = splitPagesDc.getMutableItems();
        bOk = validateAllInput(lstSplitPages);
        if(bOk){
            dokumentService.splitDocument(getFahrzeugDokument(), getFd(), lstSplitPages);
            closeWithDefaultAction();
        }
    }

    private void editSplitPages(SplitPages p_SplitPages){

        int nCount = 0;
        String sSeiten = "";
        List<String> lstCatgories = new ArrayList<>();
        boolean bBe = false, bAb = false, bLi = false, bLv = false, bKv = false, bRg = false, bZu = false, bVd = false, bEd = false, bCl = false, bSo = false, bNb = false;
        if(!(p_SplitPages == null)){
            sSeiten = p_SplitPages.getPage();
            lstCatgories = dokumentService.getParseListForDokumentCategories(p_SplitPages.getDocKategorie());
            if(lstCatgories.contains("BE")){bBe = true;}
            if(lstCatgories.contains("AB")){bAb = true;}
            if(lstCatgories.contains("LI")){bLi = true;}
            if(lstCatgories.contains("LV")){bLv = true;}
            if(lstCatgories.contains("KV")){bKv = true;}
            if(lstCatgories.contains("RG")){bRg = true;}
            if(lstCatgories.contains("ZU")){bZu = true;}
            if(lstCatgories.contains("VD")){bVd = true;}
            if(lstCatgories.contains("ED")){bEd = true;}
            if(lstCatgories.contains("CL")){bCl = true;}
            if(lstCatgories.contains("SO")){bSo = true;}
            if(lstCatgories.contains("NB")){bNb = true;}
        }
        dialogs.createInputDialog(this)
                .withCaption(messageBundle.formatMessage("dokumentenkategorie"))
                .withParameters(
                        InputParameter.stringParameter("seiten").withCaption(messageBundle.formatMessage("captSeite")).withDefaultValue(sSeiten),
                        InputParameter.booleanParameter("be").withCaption(messageBundle.formatMessage("captBestellung")).withDefaultValue(bBe),
                        InputParameter.booleanParameter("ab").withCaption(messageBundle.formatMessage("captAuftragsbestaetigung")).withDefaultValue(bAb),
                        InputParameter.booleanParameter("li").withCaption(messageBundle.formatMessage("captLieferbestaetigung")).withDefaultValue(bLi),
                        InputParameter.booleanParameter("lv").withCaption(messageBundle.formatMessage("captLeasingvertrag")).withDefaultValue(bLv),
                        InputParameter.booleanParameter("kv").withCaption(messageBundle.formatMessage("captKaufvertrag")).withDefaultValue(bKv),
                        InputParameter.booleanParameter("rg").withCaption(messageBundle.formatMessage("captRechung")).withDefaultValue(bRg),
                        InputParameter.booleanParameter("zu").withCaption(messageBundle.formatMessage("captZulassung")).withDefaultValue(bZu),
                        InputParameter.booleanParameter("vd").withCaption(messageBundle.formatMessage("captVerkaufsdokument")).withDefaultValue(bVd),
                        InputParameter.booleanParameter("ed").withCaption(messageBundle.formatMessage("captEntsorgungsdokument")).withDefaultValue(bEd),
                        InputParameter.booleanParameter("cl").withCaption(messageBundle.formatMessage("captCheckliste")).withDefaultValue(bCl),
                        InputParameter.booleanParameter("so").withCaption(messageBundle.formatMessage("captSonstige")).withDefaultValue(bSo),
                        InputParameter.booleanParameter("nb").withCaption(messageBundle.formatMessage("captNachbearbeitung")).withDefaultValue(bNb)
                )
                .withWidth("250")
                .withActions(DialogActions.OK_CANCEL)
                .withCloseListener(closeEvent -> {
                    if (closeEvent.getCloseAction().equals(InputDialog.INPUT_DIALOG_OK_ACTION)) {
                        String seiten =  closeEvent.getValue("seiten");
                        boolean catBe = closeEvent.getValue("be");
                        boolean catAb = closeEvent.getValue("ab");
                        boolean catLi = closeEvent.getValue("li");
                        boolean catLv = closeEvent.getValue("lv");
                        boolean catKv = closeEvent.getValue("kv");
                        boolean catRg = closeEvent.getValue("rg");
                        boolean catZu = closeEvent.getValue("zu");
                        boolean catVd = closeEvent.getValue("vd");
                        boolean catEd = closeEvent.getValue("ed");
                        boolean catCl = closeEvent.getValue("cl");
                        boolean catSo = closeEvent.getValue("so");
                        boolean catNb = closeEvent.getValue("nb");
                        if(catBe || catAb || catLi || catLv || catKv || catRg || catZu || catVd || catEd || catCl || catSo || catNb){
                                setPageToSplitWith(p_SplitPages, seiten, catBe, catAb, catLi, catLv, catKv, catRg, catCl, catZu, catVd, catEd, catSo, catNb);
                        } else {
                            notifications.create(Notifications.NotificationType.WARNING).withCaption(messageBundle.formatMessage("msgFalscheEingabe")).show();
                        }
                    }
                })
                .show();
    }

    private void setPageToSplitWith(SplitPages p_SplitPages, String seiten, boolean catBe, boolean catAb, boolean catLi, boolean catLv, boolean catKv, boolean catRg, boolean catCl, boolean catZu, boolean catVd, boolean catEd, boolean catSo, boolean catNb){

        if(!dgSplitPages.isVisible()){dgSplitPages.setVisible(true);btnSplitDocument.setEnabled(true);}
        if(p_SplitPages == null){ // insert
            SplitPages splitPages = metadata.create(SplitPages.class);
            splitPages.setPage(seiten);
            splitPages.setDocKategorie(dokumentService.getDokumentCategoryListFor(catBe, catAb, catLi, catLv, catKv, catRg, catCl, catZu, catVd, catEd, catSo, catNb));
            splitPagesDc.getMutableItems().add(splitPages);
        } else { // update
            SplitPages splitPages = dgSplitPages.getSingleSelected();
            splitPages.setPage(seiten);
            splitPages.setDocKategorie(dokumentService.getDokumentCategoryListFor(catBe, catAb, catLi, catLv, catKv, catRg, catCl, catZu, catVd, catEd, catSo, catNb));
            splitPagesDc.replaceItem(splitPages);
        }
    }

    private boolean validateAllInput(List<SplitPages> lstSplitPages){

        boolean bOk = true;

        if(lstSplitPages.size() == 0){
            notifications.create(Notifications.NotificationType.WARNING).withCaption(messageBundle.formatMessage("msgFalscheEingabe")).show();
            return false;
        }
        return bOk;
    }

    private int getMaxPageFrom(List<SplitPages> p_SplitPages){

        int nMaxPage = 0;
        int nVal = 0;
        for (Iterator<SplitPages> splitPagesIterator = p_SplitPages.listIterator(); splitPagesIterator.hasNext(); ) {
            SplitPages splitPages = splitPagesIterator.next();
            String sSplitPageSeiten = splitPages.getPage();
            if(sSplitPageSeiten.contains("-")){
                String[] strSplit = sSplitPageSeiten.split("-");
                nVal = Integer.valueOf(strSplit[1]);
            } else {
                nVal = Integer.valueOf(sSplitPageSeiten);
            }
            if(nVal > nMaxPage){nMaxPage = nVal;}
        }

        return nMaxPage;
    }

    //#################################################
    public void setFahrzeugDokument(FahrzeugDokument p_FahrzeugDokument) {
        this.fahrzeugDokument = p_FahrzeugDokument;
    }
    public FahrzeugDokument getFahrzeugDokument() {
        return fahrzeugDokument;
    }

    public void setFd(FileDescriptor p_fd) {
        this.fd = p_fd;
    }
    public FileDescriptor getFd() {
        return fd;
    }


}